change_password () {
  local PASSWORD="$(dialog --title "Change Password" --nocancel --insecure --passwordbox "Enter new password for user \"pi\"" 10 50 3>&1 1>&2 2>&3)"
  if [[ $? -ne 0 ]] || [[ $PASSWORD == "" ]]; then return 1; fi
  if [[ "$PASSWORD" == "raspberry" ]]; then
    dialog --title "Change Password" --nocancel --msgbox "That password sucks. Please use a different one :)" 10 50
    change_password
    return 0
  fi
  if [[ "$(dialog --nocancel --insecure --passwordbox "Confirm new password for user \"pi\"" 10 50 3>&1 1>&2 2>&3)" == "$PASSWORD" ]]; then
    if [[ $? != 0 ]]; then return 1; fi 
    echo -e "pi:$PASSWORD" | chpasswd
  else
    dialog --title "Change Password" --nocancel --msgbox "Passwords did not match!" 10 50
    change_password
    return 0
  fi
  unset PASSWORD
}

service_select () {
  local SERVICE_MENU=$(dialog --separate-output --nocancel --title "Select services" --checklist "Enable/disable services" 0 0 0 \
    "1" "OctoPrint" $(if [[ -f /etc/systemd/system/multi-user.target.wants/octoprint.service ]]; then echo "ON"; else echo "OFF"; fi) \
    "2" "GUI" $(if [[ $(systemctl get-default) == "graphical.target" ]]; then echo "ON"; else echo "OFF"; fi) \
    "3" "SSH" $(if [[ -f /etc/systemd/system/multi-user.target.wants/ssh.service ]]; then echo "ON"; else echo "OFF"; fi) 3>&1 1>&2 2>&3)

  SERVICE_MENU=($SERVICE_MENU)

  local ENABLE_OCTO=false
  local ENABLE_GUI=false
  local ENABLE_SSH=false

  for i in "${SERVICE_MENU[@]}"; do
    case $i in
      "1") ENABLE_OCTO=true ;;
      "2") ENABLE_GUI=true ;;
      "3") ENABLE_SSH=true ;;
    esac
  done

  if [[ $ENABLE_OCTO == true ]]; then
    systemctl enable octoprint
  else
    systemctl disable octoprint
  fi

  if [[ $ENABLE_GUI == true ]]; then
    systemctl set-default graphical.target 
  else
    systemctl set-default multi-user.target  
  fi

  if [[ $ENABLE_SSH == true ]]; then
    systemctl enable ssh 
  else
    systemctl disable ssh
  fi


<< 'EOF'
  for ((i = 0; i <= 3; i++)); do
    for n in "${SERVICE_MENU[@]}"; do
      if [[ $i == $n ]]; then
        case $i in
          "1") systemctl enable octoprint ;;
          "2") systemctl set-default graphical.target ;;
          "3") systemctl enable ssh ;;
        esac
        break
      fi
    done
    case $i in
      "1") systemctl disable octoprint ;;
      "2") systemctl set-default graphical.target ;;
      "3") systemctl disable ssh ;;
    esac
  done
EOF
}

screen_timeout() {
  local TIMEOUT=$(dialog --nocancel --title "Screen Timeout" --inputbox "Input your desired screen timeout in seconds.\nEnter \"off\" to disable the screen timeout.\n\nAdding a screen timeout can reduce screen burn in." 11 60 "0" 3>&1 1>&2 2>&3) 
  cat > /home/pi/.xtimeout << EOF
    xset s ${TIMEOUT}
    xset -dpms 
EOF
}

octo_config () {
  if [[ -f /srv/octoprint/host ]]; then
    source /srv/octoprint/host 
  else
    HOST="0.0.0.0"
    PORT="5000"
  fi

  local OCTOFORM=$(dialog --title "OctoPrint Config" --nocancel --form "Configure what port and IP OctoPrint listen on." 10 50 0 \
    "Listening IP:" 1 1 "$HOST" 1 17 20 0 \
    "Listening Port:" 2 1 "$PORT" 2 17 6 0 3>&1 1>&2 2>&3)
  OCTOFORM=($OCTOFORM)

  HOST=${OCTOFORM[0]}
  PORT=${OCTOFORM[1]}

  echo -e "HOST=$HOST\nPORT=$PORT" > /srv/octoprint/host
}
  

